<?php
##########################################################################################
# FreeWebStat 1.0
# Copyright (c) 2005 - Reimar Hoven
#
# This file is part of FreeWebStat.
#
# Version : 1.0 Release date: August 2005
# Authors: Reimar Hoven
# FreeWebStat official web site and latest version: http://www.freewebstat.com
##########################################################################################

# include all configuration data
include ( "stat_config.php" );

$startcounter = 0;

#----------------------------------------------------------------------------------

# never change this value !!!!
$version_number = "rev37";

/* This variable is set to 1 if any new entries are read */
/* If this is still 0 at the end, the logdbarchive.dta isn't written */
$writelogfile = 0;

# define the include files
include ( $server_path."includes/country.php" );

# get the ip address that should not be tracked
include ( $server_path."stat_exclude_me.php" );

# include language
if ( $language == "german"     ) { include ( $server_path."includes/language/german.php"     ); }
if ( $language == "english"    ) { include ( $server_path."includes/language/english.php"    ); }
if ( $language == "spanish"    ) { include ( $server_path."includes/language/spanish.php"    ); }
if ( $language == "dutch"      ) { include ( $server_path."includes/language/dutch.php"      ); }
if ( $language == "chinese-cn" ) { include ( $server_path."includes/language/chinese_cn.php" ); }
if ( $language == "chinese-tw" ) { include ( $server_path."includes/language/chinese_tw.php" ); }
if ( $language == "french"     ) { include ( $server_path."includes/language/french.php"     ); }
if ( $language == "turkish"    ) { include ( $server_path."includes/language/turkish.php"    ); }

unset ( $language );

#----------------------------------------------------------------------------------
$counter                  = 0;         # counter for the hits
$visitor_counter          = 0;         # counter for the visitors (the different ip values!)

$ip_archive               = array ();  # array for all different ip addresses
$browser_archive          = array ();  # array for the browser types values
$os_archive               = array ();  # array for the operating system values
$searchengines_archive    = array ();  # array for the search engine values
$searchwords_archive      = array ();  # array for the search engine values
$referer_archive          = array ();  # array for the referer values
$colordepth_archive       = array ();  # array for the colordepth values
$resolution_archive       = array ();  # array for the resolution values
$tld_archive              = array ();  # array for the top level domain values
$sld_archive              = array ();  # array for the second level domain values
$cc_archive               = array ();  # array for the country code values
$hour_archive             = array ();  # array for the hour values
$weekday_archive          = array ();  # array for the weekday values
$day_archive              = array ();  # array for the day values
$month_archive            = array ();  # array for the month values
$year_archive             = array ();  # array for the year code values
$site_archive             = array ();  # array only for the site hits

#----------------------------------------------------------------------------------
# write HTML header
echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 TRANSITIONAL//EN\"><html><head><meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\"><title>FreeWebStat 1.0 ".$version_number." </title><link rel=\"stylesheet\" type=\"text/css\" href=\"".$server_path."stat.css\"></head><body><center>";
#----------------------------------------------------------------------------------

echo "
<table id=\"menue\" summary=\"\" width=\"950\" height=\"40\" cellspacing=\"2\" cellpadding=\"0\">
 <tr>
  <td width=\"300\" align=\"left\" valign=\"top\">
   <h1><a class=\"menue\" href=\"http://www.freewebstat.com\" target=\"_blank\">Free Web Stat</a> V1.0</h1>
  </td>
  <td class=\"menue\" align=\"right\">
   FreeWebStat is registered for ".$registration_name."<br>
  </td>
 </tr>
</table>";
#---------------------------------------------------------------------------------- 
if ( file_exists ( $logfile_path."logdb.new" ) ) {                       
  unlink ( $logfile_path."logdb.new" );  # delete temp logfile
}

$logfilename = $logfile_path."logdb.dta";

if (file_exists($logfilename)) {

  $logfile     = fopen( $logfilename , "r"  );                            // open the logfile
  $logfile_new = fopen( $logfile_path."logdb.new" , "a+" );               // open the logfile
  $last_entries = fopen( $logfile_path."lastentries.dta" , "a" );         // open the last entries
  
  while ( !FEOF ( $logfile ) )                                  // as long as there are lines in the logfile
{ 
  $logfile_entries = fgetcsv ( $logfile , 60000 , "*" );        // read a single line
  
    if (1 == 1) {
      
    if ( trim ( $logfile_entries [ 0 ] ) != "" )    # if the entry is not empty
      {
	$writelogfile = 1;
	
	// Writing to lastentries.dta.
	//if ( $stat_loglast_iframe == 0 ) {
	fwrite ( $last_entries , $logfile_entries [ 0 ]."*".$logfile_entries [ 1 ]."*".$logfile_entries [ 2 ]."*".$logfile_entries [ 3 ]."*".$logfile_entries [ 4 ]."*".$logfile_entries [ 5 ]."*".$logfile_entries [ 6 ]."*".$logfile_entries [ 7 ]."*".$logfile_entries [ 8 ]."*".$logfile_entries [ 9 ]."*\n" ); 
	//}
#--------------------------------------------------------------------------------------------------------------
# check if the ip address has been tracked before      
 if ( !in_array ( $logfile_entries [ 2 ] , $ip_archive ) )
   {          
     $ip_archive [ $visitor_counter ] = $logfile_entries [ 2 ]; # save the ip address     
#--------------------------------------------------------------------------------------------------------------
     #save the hour     
     $hour = date ( "H" , $logfile_entries [ 0 ] );     
     if ( !array_key_exists ( $hour , $hour_archive ) ) { $hour_archive [ $hour ] = 1; } 
     else { $hour_archive [ $hour ] = $hour_archive [ $hour ] + 1; }     
     unset ( $hour );
     #--------------------------------------------------------------------------------------------------------------
     #save the weekday     
     $weekday = date ( "l" , $logfile_entries [ 0 ] );     
     if ( !array_key_exists ( $weekday , $weekday_archive ) ) { $weekday_archive [ $weekday ] = 1; } 
     else { $weekday_archive [ $weekday ] = $weekday_archive [ $weekday ] + 1; }     
     unset ( $weekday );
     #--------------------------------------------------------------------------------------------------------------
     #save the day     
     $day = date ( "Y-m-d" , $logfile_entries [ 0 ] );     
     if ( !array_key_exists ( $day , $day_archive ) ) { $day_archive [ $day ] = 1; } 
     else { $day_archive [ $day ] = $day_archive [ $day ] + 1; }     
     unset ( $day );
     #--------------------------------------------------------------------------------------------------------------
     #save the month     
     $month = date ( "F" , $logfile_entries [ 0 ] );     
     if ( !array_key_exists ( $month , $month_archive ) ) { $month_archive [ $month ] = 1; } 
     else { $month_archive [ $month ] = $month_archive [ $month ] + 1; }     
     unset ( $month );
     #--------------------------------------------------------------------------------------------------------------
     #save the year     
     $year = date ( "Y" , $logfile_entries [ 0 ] );     
     if ( !array_key_exists ( $year , $year_archive ) ) { $year_archive [ $year ] = 1; } 
     else { $year_archive [ $year ] = $year_archive [ $year ] + 1; }     
     unset ( $year );
     #--------------------------------------------------------------------------------------------------------------     
     if ( $logfile_entries [ 2 ] == $logfile_entries [ 3 ] )    # check if hostname the same as the ip address
      {
       $tld  = "unknown"; 
       $sld  = "unknown"; 
      } 
     else
      { 	
       $temp = split ( "\." , $logfile_entries [ 3 ] );         # split the hostname
       $tld  = $temp [ count ( $temp ) - 1 ];                   # get the top level domain 
       $sld  = $temp [ count ( $temp ) - 2 ];                   # get the second level domain
      }       
     unset ( $temp );                                           # destroy temp 
     
     # save the top level domain     
     if ( $tld != "unknown" ) { $tld = $country_array [ strtolower ( $tld ) ]."(".strtolower ( $tld ).")"; }
     
     if ( !array_key_exists ( $tld , $tld_archive ) ) { $tld_archive [ $tld ] = 1; } 
     else { $tld_archive [ $tld ] = $tld_archive [ $tld ] + 1; }
     
     # save the second level domain
     if ( !array_key_exists ( $sld , $sld_archive ) ) { $sld_archive [ $sld ] = 1; } 
     else { $sld_archive [ $sld ] = $sld_archive [ $sld ] + 1; }
     
     unset ( $tld ); # destroy tld
     unset ( $sld ); # destroy sld               
     #--------------------------------------------------------------------------------------------------------------
     $numbers = preg_split( "/\./", $logfile_entries [ 3 ] );   # get the country code of the saved ip address
     $include_file = $server_path."includes/ip_address/".$numbers[0].".php";            # define the right include file
   
     if ( file_exists ( $include_file ) )                       # does the ip file really exist 
      {
	include( $include_file );                                # include the desired file

       # get the value for the ip address
       $code = ( $numbers[0] * 16777216) + ( $numbers[1] * 65536 ) + ( $numbers[2] * 256 ) + ( $numbers[3] );

       foreach ( $ranges as $key => $value )
        { if ( $key <= $code ) { if ( $ranges [ $key ] [ 0 ] >= $code ) { $country = $ranges [ $key ] [ 1 ]; break; } } }

       if ( $country == "" ) { $country = "unknown" ; }
      }
     else
      { $country = "unknown"; }
      
      # destroy used vars
      unset ( $numbers      );
      unset ( $include_file );
      unset ( $code         );
      unset ( $ranges       );
     
     # save the country code      
     if ( $country != "unknown" ) { $country = $country_array [ strtolower ( $country ) ]."(".strtolower ( $country ).")"; } 
      
     if ( !array_key_exists ( $country , $cc_archive ) ) { $cc_archive [ $country ] = 1; } 
     else {$cc_archive [ $country ] = $cc_archive [ $country ] + 1; }
     
     unset ( $country ); # destroy two_letter_country_code
     #-------------------------------------------------------------------------------------------------------------- 
     # save the browser     
     if ( trim ( $logfile_entries [ 4 ] ) != "" )  # if the browser value is empty, do not save
      {
       if ( !array_key_exists ( $logfile_entries [ 4 ] , $browser_archive ) ) { $browser_archive [ $logfile_entries [ 4 ] ] = 1; } 
       else { $browser_archive [ $logfile_entries [ 4 ] ] = $browser_archive [ $logfile_entries [ 4 ] ] + 1; }
      }       
     
     # save the operating system
     if ( trim ( $logfile_entries [ 5 ] ) != "" )  # if the os value is empty, do not save
      {
       if ( !array_key_exists ( $logfile_entries [ 5 ] , $os_archive ) ) { $os_archive [ $logfile_entries [ 5 ] ] = 1; } 
       else { $os_archive [ $logfile_entries [ 5 ] ] = $os_archive [ $logfile_entries [ 5 ] ] + 1; }	      
      } 
     
     # save the resolution
     if ( trim ( $logfile_entries [ 8 ] ) != "" )  # if the resolution value is empty, do not save
      {          
       if ( !array_key_exists ( $logfile_entries [ 8 ] , $resolution_archive ) ) { $resolution_archive [ $logfile_entries [ 8 ] ] = 1; } 
       else { $resolution_archive [ $logfile_entries [ 8 ] ] = $resolution_archive [ $logfile_entries [ 8 ] ] + 1; }
      } 
      
     # save the colordepth
     if ( trim ( $logfile_entries [ 9 ] ) != ""  ) # if the colordepth value is empty, do not save
      {     
       if ( !array_key_exists ( $logfile_entries [ 9 ] , $colordepth_archive ) ) { $colordepth_archive [ $logfile_entries [ 9 ] ] = 1; } 
       else { $colordepth_archive [ $logfile_entries [ 9 ] ] = $colordepth_archive [ $logfile_entries [ 9 ] ] + 1; }
      } 
     
     # save the referer except the own domain name.  if the browser value is empty, do not save
     if ( ( strpos ( $logfile_entries [ 7 ] , $exception_domain ) === FALSE ) && ( trim ( $logfile_entries [ 7 ] ) != "" ) )
      {
       #---------------------------
        parse_str ( str_replace ( "?","&","___url_http_referer=".$logfile_entries [ 7 ] ) , $vars );
        $searchengine = "";
        $altterms     = "";
	    
        if ( !array_key_exists ( "su"        , $vars) ) $vars [ "su"        ] = "";   # WEB.de		    
        if ( !array_key_exists ( "catId"     , $vars) ) $vars [ "catId"     ] = "";   # AOL Katalog		    
        if ( !array_key_exists ( "dt"        , $vars) ) $vars [ "dt"        ] = "";   # Google Syndication

        if ( !array_key_exists ( "q"         , $vars) ) $vars [ "q"         ] = "";
        if ( !array_key_exists ( "p"         , $vars) ) $vars [ "p"         ] = "";
        if ( !array_key_exists ( "query"     , $vars) ) $vars [ "query"     ] = "";
        if ( !array_key_exists ( "search"    , $vars) ) $vars [ "search"    ] = "";
        if ( !array_key_exists ( "Keywords"  , $vars) ) $vars [ "Keywords"  ] = "";
        if ( !array_key_exists ( "ask"       , $vars) ) $vars [ "ask"       ] = "";
        if ( !array_key_exists ( "qkw"       , $vars) ) $vars [ "qkw"       ] = "";
        if ( !array_key_exists ( "searchfor" , $vars) ) $vars [ "searchfor" ] = "";
        if ( !array_key_exists ( "terms"     , $vars) ) $vars [ "terms"     ] = "";

        if ( preg_match ("/http.+google\..+\/.+/"             ,$vars["___url_http_referer"] ) ) { $searchengine = "Google";              $terms = $vars [ "q"         ]; }
        if ( preg_match ("/http.+altavista\..+\/.+/"          ,$vars["___url_http_referer"] ) ) { $searchengine = "Altavista";           $terms = $vars [ "q"         ]; }
        if ( preg_match ("/http.+wisenut\..+\/.+/"            ,$vars["___url_http_referer"] ) ) { $searchengine = "WiseNet";             $terms = $vars [ "q"         ]; }
        if ( preg_match ("/http.+alltheweb\..+\/.+/"          ,$vars["___url_http_referer"] ) ) { $searchengine = "AllTheWeb";           $terms = $vars [ "q"         ]; }
        if ( preg_match ("/http.+\.yahoo\..+\/.+/"            ,$vars["___url_http_referer"] ) ) { $searchengine = "Yahoo";               $terms = $vars [ "p"         ]; }
        if ( preg_match ("/http.+netscape\..+\/.+/"           ,$vars["___url_http_referer"] ) ) { $searchengine = "Netscape";            $terms = $vars [ "query"     ]; }
        if ( preg_match ("/http.+\.lycos\..+\/.+/"            ,$vars["___url_http_referer"] ) ) { $searchengine = "Lycos";               $terms = $vars [ "query"     ]; }
        if ( preg_match ("/http.+\.teoma\..+\/.+/"            ,$vars["___url_http_referer"] ) ) { $searchengine = "Teoma";               $terms = $vars [ "query"     ]; }
        if ( preg_match ("/http.+\.dmoz\..+\/.+/"             ,$vars["___url_http_referer"] ) ) { $searchengine = "dmoz";                $terms = $vars [ "search"    ]; }
        if ( preg_match ("/http.+\.overture\..+\/.+/"         ,$vars["___url_http_referer"] ) ) { $searchengine = "Overture";            $terms = $vars [ "Keywords"  ]; }
        if ( preg_match ("/http.+\.ask\..+\/.+/"              ,$vars["___url_http_referer"] ) ) { $searchengine = "AskJeeves";           $terms = $vars [ "ask"       ]; }
        if ( preg_match ("/http.+\.about\..+\/.+/"            ,$vars["___url_http_referer"] ) ) { $searchengine = "About";               $terms = $vars [ "terms"     ]; }
        if ( preg_match ("/http.+\.looksmart\..+\/.+/"        ,$vars["___url_http_referer"] ) ) { $searchengine = "LookSmart";           $terms = $vars [ "key"       ]; }
        if ( preg_match ("/http.+\.excite\..+\/.+/"           ,$vars["___url_http_referer"] ) ) { $searchengine = "Excite";              $terms = $vars [ "qkw"       ]; }
        if ( preg_match ("/http.+\.iwon\.com.+\/.+/"          ,$vars["___url_http_referer"] ) ) { $searchengine = "IWon";                $terms = $vars [ "searchfor" ]; }
        if ( preg_match ("/http.+\.webcrawler\.com.+\/.+/"    ,$vars["___url_http_referer"] ) ) { $searchengine = "WebCrawler";          $terms = $vars [ "qkw"       ]; }
        if ( preg_match ("/http.+\.msn\..+\/.+/"              ,$vars["___url_http_referer"] ) ) { $searchengine = "MSN";                 $terms = $vars [ "q"]; $altterms = $vars [ "origq" ]; }
        if ( preg_match ("/http.+fireball\..+\/.+/"           ,$vars["___url_http_referer"] ) ) { $searchengine = "FireBall";            $terms = $vars [ "query"     ]; }
        if ( preg_match ("/http.+web\..+\/.+/"                ,$vars["___url_http_referer"] ) ) { $searchengine = "WEB.de";              $terms = $vars [ "su"        ]; }
        if ( preg_match ("/http.+\.aol\..+\/.+/"              ,$vars["___url_http_referer"] ) ) { $searchengine = "AOL";                 $terms = $vars [ "q"         ]; }
        if ( preg_match ("/http.+\.aolsvc\..+\/.+/"           ,$vars["___url_http_referer"] ) ) { $searchengine = "AOL Katalog";         $terms = $vars [ "catId"     ]; }
        if ( preg_match ("/http.+googlesyndication\..+\/.+/"  ,$vars["___url_http_referer"] ) ) { $searchengine = "Google Syndication";  $terms = $vars [ "dt"        ]; }
        if ( preg_match ("/http.+216.239\..+\/.+/"            ,$vars["___url_http_referer"] ) ) { $searchengine = "Google IP";           $terms = $vars [ "q"         ]; }
        if ( preg_match ("/http.+216.239\..+\/.+/"            ,$vars["___url_http_referer"] ) ) { $searchengine = "Google IP";           $terms = $vars [ "search"    ]; }
        if ( preg_match ("/http.+64.233\..+\/.+/"             ,$vars["___url_http_referer"] ) ) { $searchengine = "Google IP";           $terms = $vars [ "q"         ]; }
        if ( preg_match ("/http.+64.233\..+\/.+/"             ,$vars["___url_http_referer"] ) ) { $searchengine = "Google IP";           $terms = $vars [ "search"    ]; }
	
	$terms = str_replace( '\"', "", $terms );   # delete \" 
	$terms = strtolower( $terms );              # string to lower		
	
	$terms = str_replace( "+" , " ", $terms );  # replace + with space
	$terms = str_replace( "-" , " ", $terms );  # replace - with space
	$terms = str_replace( "ä", "", $terms );  # replace 		
	$terms = str_replace( "ö", "", $terms );  # replace 		
	$terms = str_replace( "ü", "", $terms );  # replace 
	$terms = str_replace( "Ü", "", $terms );  # replace 
	$terms = str_replace( "", "", $terms );  # replace 	
	
	#---------------------------------------------------------------------	
	  if ( $searchengine )
           {
            $message    = $searchengine;
            $termarray  = preg_split ( "/ /" , $terms );
            #$search_words_temp = "[";
            $search_words_temp = "";

            while ( list ( $key , $value ) = each ( $termarray ) )
             {
              $message.= " ".$value;
              $search_words_temp.= $value." ";
             }

            if( $altterms )
             {
              $termarray = preg_split("/ /",$altterms );
              while ( list  ($key , $value) = each ( $termarray ) )
               {
                $message.= " ".$value;
                $search_words_temp.= $value." ";
               }
             }
             #$search_words_temp.= "]";
           }
        #---------------------------------------------------------------------              
          if ( trim ( $searchengine ) != "" )
           {
            if ( array_key_exists ( $searchengine , $searchengines_archive ) ) { $searchengines_archive [ $searchengine ] = $searchengines_archive [ $searchengine ] + 1; }
            else { $searchengines_archive [ $searchengine ] = 1; }
           } 
          if ( trim ( $search_words_temp ) != "" )
           {
            if ( array_key_exists ( $search_words_temp , $searchwords_archive ) ) { $searchwords_archive [ $search_words_temp ] = $searchwords_archive [ $search_words_temp ] + 1; }
            else { $searchwords_archive [ $search_words_temp ] = 1; }
           }
        #---------------------------------------------------------------------  
       if ( ( !array_key_exists ( $logfile_entries [ 7 ] , $referer_archive ) ) && ( strpos ( $logfile_entries [ 7 ] , "google" ) === false ) )
        {        
         $referer_archive [ $logfile_entries [ 7 ] ] = 1; } 
         else { $referer_archive [ $logfile_entries [ 7 ] ] = $referer_archive [ $logfile_entries [ 7 ] ] + 1; 
        }
      }      
     $visitor_counter = $visitor_counter + 1; 	# set the visitor counter + 1     
    }    
   #----------------------------------------------------------------------------------   
   # save the site hits
   if ( !array_key_exists ( $logfile_entries [ 6 ] , $site_archive ) ) { $site_archive [ $logfile_entries [ 6 ] ] = 1; } 
   else { $site_archive [ $logfile_entries [ 6 ] ] = $site_archive [ $logfile_entries [ 6 ] ] + 1; }
   #----------------------------------------------------------------------------------   
   $counter = $counter + 1;      # count the hits 
   }
   
   }
}
  
  unset  ( $logfile_entries  );             # destroy the logfile_entries var  
#----------------------------------------------------------------------------------   
  fclose ( $logfile          );             # destroy the file open
  unset  ( $logfile          );             # destroy the logfile var
  
  fclose ( $logfile_new      );             # destroy the file open  
  unset  ( $logfile_new      );             # destroy the logfile var  
  
  unlink ( $logfile_path."logdb.dta" );       # delete logfile
  rename ( $logfile_path."logdb.new" , $logfile_path."logdb.dta" );  # rename logfile    
  
}

#----------------------------------------------------------------------------------   

# Removing the first lines in lastentries.dta, so that the number of lines matches the $last_entries_count.

$last_entries_file = file($logfile_path."lastentries.dta");
$line_count = count($last_entries_file);

$start = $line_count - $last_entries_count;

if ($start > 0) {
  
  $out = fopen($logfile_path."lastentries.dta",'w');
  
  for ($i = $start; $i < $line_count; $i++) {
    fwrite( $out, $last_entries_file[$i] );
  }
  fclose($out);
}


#----------------------------------------------------------------------------------  
 # read the logfile archive and concat the arrays
  
if ( file_exists ( $logfile_path."logdbarchive.dta" ) )
 {  
  # define logfile arrays
  $hour_archive_logfile           = array ();
  $weekday_archive_logfile        = array ();
  $day_archive_logfile            = array ();
  $month_archive_logfile          = array ();
  $year_archive_logfile           = array ();
  $site_archive_logfile           = array ();
  $searchengines_archive_logfile  = array ();
  $searchwords_archive_logfile    = array ();
  $cc_archive_logfile             = array ();
  $tld_archive_logfile            = array ();
  $sld_archive_logfile            = array ();
  $browser_archive_logfile        = array ();
  $os_archive_logfile             = array ();
  $referer_archive_logfile        = array ();
  $resolution_archive_logfile     = array ();
  $colordepth_archive_logfile     = array ();
  
  # function for parsing a value line
  function parser ( $line , $back )
    { 
      while ( strlen ( $line ) > 2 )
	{
        $position1      = strpos ( $line , ";" );
        $temp           = substr ( $line , 0 , $position1 );          
        $line           = substr ( $line , $position1+1 , strlen ( $line ) );         
        $position2      = strpos ( $line , ";" );
        $back [ $temp ] = substr ( $line , 0 , $position2 );            
        $line           = substr ( $line , $position2+1 , strlen ( $line ) );
       }      
     unset ( $line      );     
     unset ( $position1 );
     unset ( $position2 );
     unset ( $temp      );   
     return $back;     	  	
   }

# function to detect the right values
  function word_matching ( $pos , $temp , $word , $which_array )
    {
      if ( substr ( $temp , 0 , $pos ) == $word )
	{         
	  $temp        = substr ( $temp , $pos , strlen ( $temp ) );
	  $which_array = parser ( $temp , $which_array );
	}  
      unset ( $temp      );
      unset ( $position1 );
      unset ( $position2 );
      unset ( $word      );
      
      return $which_array;
    }
  
 # read the logfile archive
 $logfile = fopen ( $logfile_path."logdbarchive.dta" , "r" );
  while ( !FEOF ( $logfile ) )
    {
      $logfile_line = fgets ( $logfile , 4096  );
      
      $hour_archive_logfile           = word_matching ( 5  , $logfile_line , "hour:"             , $hour_archive_logfile           );
      $weekday_archive_logfile        = word_matching ( 8  , $logfile_line , "weekday:"          , $weekday_archive_logfile        );
      $day_archive_logfile            = word_matching ( 4  , $logfile_line , "day:"              , $day_archive_logfile            );
      $month_archive_logfile          = word_matching ( 6  , $logfile_line , "month:"            , $month_archive_logfile          );
      $year_archive_logfile           = word_matching ( 5  , $logfile_line , "year:"             , $year_archive_logfile           );
      $site_archive_logfile           = word_matching ( 5  , $logfile_line , "site:"             , $site_archive_logfile           );
      $searchengines_archive_logfile  = word_matching ( 14 , $logfile_line , "searchengines:"    , $searchengines_archive_logfile  );
      $searchwords_archive_logfile    = word_matching ( 12 , $logfile_line , "searchwords:"      , $searchwords_archive_logfile    );
      $cc_archive_logfile             = word_matching ( 8  , $logfile_line , "country:"          , $cc_archive_logfile             );
      $tld_archive_logfile            = word_matching ( 4  , $logfile_line , "tld:"              , $tld_archive_logfile            );
      $sld_archive_logfile            = word_matching ( 4  , $logfile_line , "sld:"              , $sld_archive_logfile            );
      $browser_archive_logfile        = word_matching ( 8  , $logfile_line , "browser:"          , $browser_archive_logfile        );
      $os_archive_logfile             = word_matching ( 3  , $logfile_line , "os:"               , $os_archive_logfile             );
      $referer_archive_logfile        = word_matching ( 8  , $logfile_line , "referer:"          , $referer_archive_logfile        );
      $resolution_archive_logfile     = word_matching ( 11 , $logfile_line , "resolution:"       , $resolution_archive_logfile     );
      $colordepth_archive_logfile     = word_matching ( 11 , $logfile_line , "colordepth:"       , $colordepth_archive_logfile     ); 
      
    }
  
 fclose ( $logfile );
 unset  ( $logfile );
 
 # function to transfer the arrays
 function array_transfer ( $array_in , $array_out )
 {  		
  foreach ( $array_in as $key => $var ) 
   {
    if ( array_key_exists ( $key , $array_out ) ) $array_out [ $key ] = $array_out [ $key ] + $array_in [ $key ];
    else $array_out [ $key ] = 1;    
    next( $array_in ); 
   }
   return $array_out;	
 }

#transfer the arrays
 $hour_archive          = array_transfer ( $hour_archive          , $hour_archive_logfile           );
 $weekday_archive       = array_transfer ( $weekday_archive       , $weekday_archive_logfile        );
 $day_archive           = array_transfer ( $day_archive           , $day_archive_logfile            );
 $month_archive         = array_transfer ( $month_archive         , $month_archive_logfile          );
 $year_archive          = array_transfer ( $year_archive          , $year_archive_logfile           );
 $site_archive          = array_transfer ( $site_archive          , $site_archive_logfile           );
 $searchengines_archive = array_transfer ( $searchengines_archive , $searchengines_archive_logfile  );
 $searchwords_archive   = array_transfer ( $searchwords_archive   , $searchwords_archive_logfile    );
 $cc_archive            = array_transfer ( $cc_archive            , $cc_archive_logfile             );
 $tld_archive           = array_transfer ( $tld_archive           , $tld_archive_logfile            );
 $sld_archive           = array_transfer ( $sld_archive           , $sld_archive_logfile            );
 $browser_archive       = array_transfer ( $browser_archive       , $browser_archive_logfile        );
 $os_archive            = array_transfer ( $os_archive            , $os_archive_logfile             );
 $referer_archive       = array_transfer ( $referer_archive       , $referer_archive_logfile        );
 $resolution_archive    = array_transfer ( $resolution_archive    , $resolution_archive_logfile     );
 $colordepth_archive    = array_transfer ( $colordepth_archive    , $colordepth_archive_logfile     ); 
 
 
# unset the arrays
 unset ( $hour_archive_logfile           );
 unset ( $weekday_archive_logfile        );
 unset ( $day_archive_logfile            );
 unset ( $month_archive_logfile          );
 unset ( $year_archive_logfile           );
 unset ( $site_archive_logfile           );
 unset ( $searchengines_archive_logfile  );
 unset ( $searchwords_archive_logfile    );
 unset ( $cc_archive_logfile             );
 unset ( $tld_archive_logfile            );
 unset ( $sld_archive_logfile            );
 unset ( $browser_archive_logfile        );
 unset ( $os_archive_logfile             );
 unset ( $referer_archive_logfile        );
 unset ( $resolution_archive_logfile     );
 unset ( $colordepth_archive_logfile     );
}
#----------------------------------------------------------------------------------
  function horizontalbar ( $howmuch )
   { echo "<img src=\"chart.gif\" border=\"0\" height=\"12\" width=\"".( $howmuch )."\">"; }
#----------------------------------------------------------------------------------  
  # stat summary, avoiding divising by zero.
$diviser = array_sum ( $year_archive );
if ($diviser < 1) {
  $diviser = 1;
}
echo "
 <table id=\"content\" summary=\"\" width=\"950\" height=\"40\" cellspacing=\"2\" cellpadding=\"0\">
 <tr> 
  <td class=\"content\" align=\"left\">
   <h2>".$title_summary."</h2>
   <br>
    ".$title_count_visitors.": ".array_sum ( $year_archive )."<br>
    ".$title_hits_total.":     ".array_sum ( $site_archive )."<br>
    ".$title_hits_per_visitor.": ".(int ) round ( array_sum ( $site_archive ) / $diviser )."<br>
  </td>
 </tr>
 </table>";
#----------------------------------------------------------------------------------    
# show the stat
  function show_stat ( $title, $values , $number , $widthkey , $parameter , $linkactive )
   {    
    echo "  <td class=\"content\" align=\"left\">
            <h2>".$title." ( ".array_sum ( $values )." ) </h2>
            <br>
         ";   

    echo "<table id=\"stat\" summary=\"\" cellspacing=\"2\" cellpadding=\"0\">";           
    $temp_counter = 0;    
    foreach ( $values as $var )
     {
      if ( $temp_counter <= $number )
       {
         echo "<th><th align=\"left\" width=\"".$widthkey."\">";
         if ( $linkactive == 1 ) { echo "<a class=\"menue\" href=\"".key ( $values )."\" target=\"_blank\">".key ( $values )."</a>"; }
         else { echo key ( $values ); }
         echo "</th>";

         echo "<td width=\"80\" bgcolor=\"#314953\">";
         if ( $parameter == 2 )          
          { echo horizontalbar ( ( int ) round ( $var/max ( $values ) * 100 ) ); }
         else
          { echo horizontalbar ( ( int ) round ( $var/array_sum ( $values ) * 100 ) ); }
         echo "</td>";

         echo "<td width=\"50\" align=\"right\">";
         echo ( int ) round ( $var/array_sum ( $values ) * 100 )." %";
         echo "</td>";

         echo "<th width=\"50\" align=\"right\">";
         echo $var;
         echo "</th></tr>";       	
        $temp_counter = $temp_counter + 1;
        next ( $values ); 
       }
      else
       { break; }	  
     }     
    echo "</table></td>";   
   }

  
  
  $browser_archive_shown = array();
  
/* Browser */
  if ($show_detailed_browser == 0 ) {
    
    foreach ( $browser_archive as $key => $value ) {
      
      $found = 0;
      
      foreach ( $major_category_browser as $key2 => $value2 ) {
	
	if ( eregi ( $key2 , $key ) ) {
	  $major_category_browser[$key2] = $value2 + $value;
	  $found = 1;
	}
      }
      
      if ($found == 0) {
	if (array_key_exists($key, $major_category_browser)) {
	  ;
	}
	else {
	  $major_category_browser[$key] = $value;
	} 
      }
    }
    arsort($major_category_browser);
    $browser_archive_shown = $major_category_browser;
  }
  else {
    arsort ( $browser_archive );
    $browser_archive_shown = $browser_archive;
  }
  
  
   
  $os_archive_shown = array();
  
 /* OS */
  if ($show_detailed_os == 0 )
    {
      foreach ( $os_archive as $key => $value ) {
	
	$found = 0;
	
	foreach ( $major_category_OS as $key2 => $value2 ) {
	  
	  if ( eregi ( $key2 , $key ) ) {
	    $major_category_OS[$key2] = $value2 + $value;
	    $found = 1;
	  }
	}
	
	if ($found == 0) {
	  if (array_key_exists($key, $major_category_OS)) {
	    ;
	  }
	  else {
	    $major_category_OS[$key] = $value;
	  } 
	}
      }
      
      arsort($major_category_OS);
      $os_archive_shown = $major_category_OS;
    }
  else {
    arsort ( $os_archive );
    $os_archive_shown = $os_archive;
  }
  
#----------------------------------------------------------------------------------    
  # sort the various arrays 
  arsort ( $site_archive          ); # asort ascending
  #arsort ( $os_archive            ); # asort ascending
  #arsort ( $browser_archive       ); # asort ascending
  arsort ( $referer_archive       ); # asort ascending
  arsort ( $resolution_archive    ); # asort ascending
  arsort ( $colordepth_archive    ); # asort ascending
  arsort ( $tld_archive           ); # asort ascending
  arsort ( $sld_archive           ); # asort ascending
  arsort ( $cc_archive            ); # asort ascending
  arsort ( $searchwords_archive   ); # asort ascending
  arsort ( $searchengines_archive ); # asort ascending
  
  arsort ( $weekday_archive       ); # ksort descending
  ksort  ( $hour_archive          ); # ksort descending  
  krsort ( $day_archive           ); # asort descending
  ksort  ( $month_archive         ); # asort descending
  ksort  ( $year_archive          ); # asort descending

#----------------------------------------------------------------------------------   
  unset  ( $yesterday );           # destroy yesterday
#----------------------------------------------------------------------------------
  # read the last logfile entries from logdb.dta and save them to an external html file
  
  if ( file_exists ( $logfile_path."logdb.dta" ) ) 
    {     

  if ( file_exists ( $logfile_path."logdb.html" ) )               # delete html last logfile
{ unlink ( $logfile_path."logdb.html" ); }

$logdblast = fopen ( $logfile_path."logdb.html" , "a+"  );      // open the html file

//$logfile = fopen ( $logfile_path."logdb.dta" , "r"  );
$logfile = fopen ( $logfile_path."lastentries.dta" , "r"  );  
 
if ($stat_loglast_iframe == 1) {
  
  fwrite ( $logdblast , "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 TRANSITIONAL//EN\"><html><head><meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\"><title>stat 1.0</title><link rel=\"stylesheet\" type=\"text/css\" href=\"".$server_path."stat.css\"></head><body>" );
  
  fwrite ( $logdblast , "<center>" );
  
  // write the table header
  fwrite ( $logdblast , "<table id=\"loglast\" summary=\"free web stat\" width=\"940\" cellspacing=\"1\" cellpadding=\"0\">" ); 
}
 else {
   fwrite ( $logdblast , "<center>" );
   
   // write the table header
   fwrite ( $logdblast , "<table id=\"loglast\" summary=\"free web stat\" width=\"940\" cellspacing=\"1\" cellpadding=\"0\">" ); 
 }
 
 $counter = 0;
 $line_count = count( file( $logfile_path."lastentries.dta" ) );
 $start = $line_count - $last_entries_count_shown;
 
 $logfile = fopen ( $logfile_path."lastentries.dta" , "r"  );
 
# as long as there are lines in the logfile and counter is less than limit.
while ( !FEOF ( $logfile ) )
{
  $logfile_entries = fgetcsv ( $logfile , 60000 , "*" );        // read a single line    
  
  /* Only adding the last ($last_entries_count_shown) entries */
  if ($counter++ > $start) {
  
    if ( $logfile_entries != 0 )
      {    
	fwrite ( $logdblast , "<tr>"            );
	
	fwrite ( $logdblast , "<td id=\"loglast\" width=\"20\">"             );
	fwrite ( $logdblast , date ( "d.m.Y" , $logfile_entries [ 0 ] ) );
	fwrite ( $logdblast , "</td>"           );
	
	fwrite ( $logdblast , "<td id=\"loglast\" width=\"40\">"             );
	fwrite ( $logdblast , $logfile_entries [ 2 ] );
	fwrite ( $logdblast , "</td>"           );
	
	fwrite ( $logdblast , "<td id=\"loglast\" width=\"40\">"             );
	fwrite ( $logdblast , $logfile_entries [ 6 ] );
	fwrite ( $logdblast , "</td>"           );
	
	fwrite ( $logdblast , "<td id=\"loglast\" width=\"390\">"            );
	fwrite ( $logdblast , "<a class=\"menue\" href=\"".$logfile_entries [ 7 ]."\" target=\"_blank\" >".$logfile_entries [ 7 ]."</a>" );
	fwrite ( $logdblast , "</td>"           );
	
	fwrite ( $logdblast , "<td id=\"loglast\" width=\"100\">"            );
	fwrite ( $logdblast , $logfile_entries [ 5 ]."<br>".$logfile_entries [ 4 ] );
	fwrite ( $logdblast , "</td>"           );
      }   
    fwrite ( $logdblast , "</tr>"           );    
  }
}

fwrite ( $logdblast , "</table></center>"           );     # write the table footer

if ($stat_loglast_iframe == 1) {
  fwrite ( $logdblast , "</body></html>" );     # write the html footer
 }

fclose ( $logdblast );  
unset  ( $logdblast );  

fclose ( $logfile   );
unset  ( $logfile   );  

}

#----------------------------------------------------------------------------------
  # call the stat function 
  
if ( $stat_loglast != 0 )
{ 

  if ($stat_loglast_iframe == 1) {
    echo "<table id=\"content\" summary=\"\" width=\"950\" cellspacing=\"2\" cellpadding=\"0\"><tr>";
    echo "<iframe src=\"".$logfile_path."logdb.html\" width=\"950\" height=\"400\" name=\"loglast\" scrolling=\"yes\" marginheight=\"0\" marginwidth=\"0\" frameborder=\"0\"></iframe>";
    echo "</tr></table>";
  }
  else {
 
    $logfile = fopen ( $logfile_path."logdb.html" , "r"  );
    
    while ( !FEOF ( $logfile ) )
      {   
	$logfile_entries = fgets ( $logfile , 4096 );
	echo $logfile_entries;
      }
    fclose ( $logfile );
  }
}

if ( $stat_hour != 0 || ( $stat_day != 0 ))
{ 
    echo "<table id=\"content\" summary=\"\" width=\"950\" cellspacing=\"2\" cellpadding=\"0\"><tr>";
    
    if ( $stat_hour != 0 ) {
	show_stat ( $title_hour             , $hour_archive          , $stat_hour_count  , 100 , $stat_hour , 0 );
    }   
    if ( $stat_day != 0 ) {
	show_stat ( $title_day              , $day_archive           , $stat_day_count       , 120 , $stat_day     , 0 );
    }
    echo "</tr></table>";
} 

if ( ( $stat_weekday != 0 ) || ( $stat_month != 0 ) )
{  
 echo "<table id=\"content\" summary=\"\" width=\"950\" cellspacing=\"2\" cellpadding=\"0\"><tr>";
 
 if ( $stat_weekday != 0 ) {
     show_stat ( $title_weekday          , $weekday_archive       , $stat_weekday_count   , 120 , $stat_weekday , 0 );
 }
 if ( $stat_month != 0 ) {
     show_stat ( $title_month            , $month_archive         , $stat_month_count , 120 , $stat_month , 0 );
 }
 echo "</tr></table>";
}  

if ( ( $stat_year != 0 ) )
{  
    echo "<table id=\"content\" summary=\"\" width=\"950\" cellspacing=\"2\" cellpadding=\"0\"><tr>";   
    show_stat ( $title_year             , $year_archive          , $stat_year_count  , 120 , $stat_year  , 0 );
    echo "</tr></table>";
}  

if ( $stat_site != 0 )
{  
    echo "<table id=\"content\" summary=\"\" width=\"950\" cellspacing=\"2\" cellpadding=\"0\"><tr>";   
    show_stat ( $title_site             , $site_archive          , $stat_site_count  , 320 , $stat_site , 0 );
    echo "</tr></table>";
}  

if ( ( $stat_searchwords != 0 ) || ( $stat_searchengines != 0 ) )
{  
    echo "<table id=\"content\" summary=\"\" width=\"950\" cellspacing=\"2\" cellpadding=\"0\"><tr>";    
    
    if ( $stat_searchwords != 0 ) {
	show_stat ( $title_searchwords      , $searchwords_archive   , $stat_searchwords_count    , 200 , $stat_searchwords   , 0 );
    }
    
    if ( $stat_searchengines != 0 ) {
	show_stat ( $title_searchengines    , $searchengines_archive , $stat_searchengines_count  , 140 , $stat_searchengines , 0 );
    }
    echo "</tr></table>";
}  

if ( $stat_referer != 0 )
{  
    echo "<table id=\"content\" summary=\"\" width=\"950\" cellspacing=\"2\" cellpadding=\"0\"><tr>";    
    show_stat ( $title_referer          , $referer_archive       , $stat_referer_count , 800 , $stat_referer , 1 );
    echo "</tr></table>";
 }  
 
if ( $stat_cc != 0 ) {
    echo "<table id=\"content\" summary=\"\" width=\"950\" cellspacing=\"2\" cellpadding=\"0\"><tr>";       
    show_stat ( $title_cc               , $cc_archive            , $stat_cc_count , 140 , $stat_cc , 0 );
    echo "</tr></table>"; 
}


if ( $stat_tld != 0 || $stat_sld != 0)
{  
    echo "<table id=\"content\" summary=\"\" width=\"950\" cellspacing=\"2\" cellpadding=\"0\"><tr>";       
    
    if ( $stat_tld != 0 ) {
	show_stat ( $title_tld              , $tld_archive           , $stat_tld_count , 140 , $stat_tld , 0 );
    }
    
    if ( $stat_sld != 0 ) {
	show_stat ( $title_sld              , $sld_archive           , $stat_sld_count , 160 , $stat_sld , 0 );
    }
    echo "</tr></table>"; 
}  

if ( ( $stat_browser != 0 ) || ( $stat_os != 0 ))
{  
    echo "<table id=\"content\" summary=\"\" width=\"950\" cellspacing=\"2\" cellpadding=\"0\"><tr>";       
    
    if ( $stat_browser != 0 ) {
      show_stat ( $title_browser          , $browser_archive_shown , $stat_browser_count , 150 , $stat_browser , 0 );
    }
    
    if ( $stat_os != 0 ) {
      show_stat ( $title_os               , $os_archive_shown      , $stat_os_count      , 120 , $stat_os      , 0 );
    }
    echo "</tr></table>";  
}  


if (( $stat_resolution != 0 ) || ( $stat_colordepth != 0 ))
{ 	  
    echo "<table id=\"content\" summary=\"\" width=\"950\" cellspacing=\"2\" cellpadding=\"0\"><tr>";       
    
    if ($stat_resolution != 0 ) {
      show_stat ( $title_resolution       , $resolution_archive    , $stat_resolution_count , 120 , $stat_resolution , 0 );
    }
    if ( $stat_colordepth != 0 ) {
      show_stat ( $title_colordepth       , $colordepth_archive    , $stat_colordepth_count , 120 , $stat_colordepth , 0 );
    }
    echo "</tr></table>";   
}  

#----------------------------------------------------------------------------------
  # write the logfile  
  function write_logfile ( $value_array , $title )
   {
     $logfile = fopen ( $GLOBALS['logfile_path']."logdbarchive.dta" , "a+" );
     
    fwrite ( $logfile , $title.":" );   # write the title   
   
    foreach ( $value_array as $var )
     {      
      #echo key ( $value_array )."->".$var."<br>";
      fwrite ( $logfile , key ( $value_array ).";".$var.";" );  
      next ( $value_array ); 
     }
     
    fwrite ( $logfile , "\n" );    # write the carriage return
       
    fclose ( $logfile );           # destroy the file open
    unset  ( $logfile );           # destroy the logfile var  	
   }

if ($writelogfile == 1) {
  
  if ( file_exists ( $logfile_path."logdbarchive.dta" ) ) {
    rename($logfile_path."logdbarchive.dta", $logfile_path."logdbarchive.tmp");
  }
  
  // write the new logfile archive   
  write_logfile ( $hour_archive           , "hour"             ); 
  write_logfile ( $weekday_archive        , "weekday"          ); 
  write_logfile ( $day_archive            , "day"              );
  write_logfile ( $month_archive          , "month"            );
  write_logfile ( $year_archive           , "year"             );
  write_logfile ( $site_archive           , "site"             );
  write_logfile ( $searchengines_archive  , "searchengines"    );
  write_logfile ( $searchwords_archive    , "searchwords"      );
  write_logfile ( $cc_archive             , "country"          );
  write_logfile ( $tld_archive            , "tld"              );
  write_logfile ( $sld_archive            , "sld"              );
  write_logfile ( $browser_archive        , "browser"          );
  write_logfile ( $os_archive             , "os"               );
  write_logfile ( $referer_archive        , "referer"          );
  write_logfile ( $resolution_archive     , "resolution"       );
  write_logfile ( $colordepth_archive     , "colordepth"       );
   
   
   if ( file_exists ( $logfile_path."logdbarchive.tmp" ) ) {
   # If no error, the renamed file is deleted								     
     unlink ( $logfile_path."logdbarchive.tmp" ); 
   } # delete the logfile archive
       }
#----------------------------------------------------------------------------------
#write HTML footer
echo "<table id=\"copyright\" summary=\"\" width=\"950\" cellpadding=\"0\" cellpadding=\"0\"><tr><td valign=\"top\" align=\"center\">Copyright &copy; 2005 by Reimar Hoven | All Rights Reserved</td></tr></table></center></body></html>";
#----------------------------------------------------------------------------------

#----------------------------------------------------------------------------------
# save the summary to an external html file

if ( file_exists ( $logfile_path."statshort.html" ) )               # delete html short logfile
{ 
  unlink ( $logfile_path."statshort.html" ); }

$logshort = fopen ( $logfile_path."statshort.html" , "a+"  );       # open the html file
fwrite ( $logshort , "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 TRANSITIONAL//EN\">
<html>
  <head>
    <meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
    <title>FreeWebStat 1.0 ".$version_number." Summary</title>
    <link rel=\"stylesheet\" type=\"text/css\" href=\"".$server_path."stat.css\">
  </head>
  <body>" );

$diviser = array_sum ( $year_archive );
if ($diviser < 1) {
  $diviser = 1;
}
fwrite ( $logshort , "
    <table id=\"short-summary\" summary=\"\" width=\"140\" height=\"40\" cellspacing=\"2\" cellpadding=\"0\">
      <tr> 
        <td class=\"short-summary\">
          <strong>Visists:</strong>
          <br /><br />
          Visitors total: ".array_sum ( $year_archive )."<br />
          Site hits tot.: ".array_sum ( $site_archive )."<br />
          Hits per visitor: ".(int ) round ( array_sum ( $site_archive ) / ($diviser))."<br />
        </td>
      </tr>
    </table>");
fwrite ( $logshort , "</body></html>" );         # write the html footer   

fclose ( $logshort );  
unset  ( $logshort );
#----------------------------------------------------------------------------------
?>