<?php
##########################################################################################
# FreeWebStat 1.0
# Copyright (c) 2005 - Reimar Hoven
#
# This file is part of FreeWebStat.
#
# Version : 1.0 Release date: August 2005
# Authors: Reimar Hoven
# FreeWebStat official web site and latest version: http://www.freewebstat.com
##########################################################################################

#define your name
$registration_name = "Your Name";
#----------------------------------------------------------------------------------
# define path to stat
# if you enter any directory, put a "/" behind the string!
# define path to stat

# Changed
# Added a logfile_path variable. The $logfile_path should lead to a write-enabled area.
# $server_path is replaced by $logfile_path in relation with: logdb.dta, logdbarchive.dta, logdb.html, statshort.html.

$server_path = "";     # the last char must be a "/"
$logfile_path = "";    # the last char must be a "/"

#----------------------------------------------------------------------------------
# which domain should be excluded from the referer
# do not put a "www." before it!
$exception_domain   = "yourdomain.com"; 
#----------------------------------------------------------------------------------
# define language
#$language = "german";
$language = "english";
#$language = "spanish";
#$language = "dutch";
#$language = "chinese-cn";
#$language = "chinese-tw";
#$language = "french";
#$language = "turkish";
#----------------------------------------------------------------------------------
# define if you want to see the last logfile entries ( 1 = on | 0 = off )
$stat_loglast       = 1;

$stat_loglast_iframe = 0;    #1 = on, 0 = off

# If not iframe
$last_entries_count = 200;
$last_entries_count_shown = 10; # Must be less than $last_entries_count

$show_detailed_os = 0;       #1 = on, 0 = off
$show_detailed_browser = 0;  #1 = on, 0 = off


 /* The entries that contain any of the words below will be summed together */
$major_category_browser = array("Opera" => 0, 
				"Mozilla" => 0, 
				"Internet Explorer" => 0, 
				"IE" => 0, // IE based browsers
				"Firefox" => 0, 
				"Safari" => 0, 
				"Konqueror" => 0, 
				"Netscape" => 0);

/* The entries that contain any of the words below will be summed together */
$major_category_OS = array("Mac" => 0, 
			   "Linux" => 0);

#----------------------------------------------------------------------------------
# define the stat modules you want to see...1 means active (default), 0 means deactive
# define : take the max value of each stat for the 100% value...2 means active, 1 means deactive (default)
$stat_hour          = 2;
$stat_weekday       = 1;
$stat_day           = 2;
$stat_month         = 1;
$stat_year          = 1;
$stat_site          = 1;
$stat_searchengines = 1;
$stat_searchwords   = 1;
$stat_cc            = 1;
$stat_tld           = 1;
$stat_sld           = 1;
$stat_browser       = 1;
$stat_os            = 1;
$stat_referer       = 1;
$stat_resolution    = 1;
$stat_colordepth    = 1;
#----------------------------------------------------------------------------------
# define the amount of lines per stat module
$stat_hour_count          = 24;
$stat_weekday_count       = 7;
$stat_day_count           = 30;
$stat_month_count         = 12;
$stat_year_count          = 3;
$stat_site_count          = 20;
$stat_searchengines_count = 20;
$stat_searchwords_count   = 40;
$stat_cc_count            = 60;
$stat_tld_count           = 60;
$stat_sld_count           = 60;
$stat_browser_count       = 1000;
$stat_os_count            = 50;
$stat_referer_count       = 200;
$stat_resolution_count    = 50;
$stat_colordepth_count    = 50;
#----------------------------------------------------------------------------------
# define the time when the same ip address should be counted as a new visitor
$yesterday  = mktime ( date ( "H" ) - 1 , date ( "i" ) , date ( "s" ) , date ( "m" ) , date ( "d" )  , date ( "Y" ) );
#----------------------------------------------------------------------------------
?>